(function (exports) {
'use strict';

var IMANotifications = function () {
    function IMANotifications() {
        babelHelpers.classCallCheck(this, IMANotifications);
    }

    babelHelpers.createClass(IMANotifications, null, [{
        key: "INITIALIZED",
        get: function get() {
            return "ima/initialize";
        }
    }, {
        key: "ADD_OVERLAY",
        get: function get() {
            return "ima/addOverlay";
        }
    }, {
        key: "REMOVE_OVERLAY",
        get: function get() {
            return "ima/removeOverlay";
        }
    }]);
    return IMANotifications;
}();

var IMAWrapper = {};

try {
  var _IMAWrapper = function (_akamai$amp$ads$AdWra) {
    babelHelpers.inherits(_IMAWrapper, _akamai$amp$ads$AdWra);

    function _IMAWrapper() {
      babelHelpers.classCallCheck(this, _IMAWrapper);
      return babelHelpers.possibleConstructorReturn(this, (_IMAWrapper.__proto__ || Object.getPrototypeOf(_IMAWrapper)).apply(this, arguments));
    }

    babelHelpers.createClass(_IMAWrapper, [{
      key: "createXML",


      /** */
      value: function createXML(xml) {
        var admedia, application, companion, companions, i, ids, j, k, len, len1, len2, overlay, prop, props, ref, vendor;
        application = xml.firstChild;
        admedia = xml.getElementsByTagName("admedia")[0];
        if (admedia == null) {
          admedia = xml.createElement("admedia");
          application.appendChild(admedia);
        }
        vendor = xml.createElement("vendor");
        vendor.setAttribute("id", "dfp");
        admedia.appendChild(vendor);
        props = [{
          value: this.config.adTagUrl,
          key: "DFP_AD_TAG_URL"
        }, {
          value: this.config.maxBitrate,
          key: "DFP_MAX_BITRATE"
        }, {
          value: this.config.sceneMarkers,
          key: "displaySceneMarkers"
        }, {
          value: this.config.ppid,
          key: "DFP_PPID"
        }];
        for (i = 0, len = props.length; i < len; i++) {
          prop = props[i];
          if (prop.value != null) {
            this.createProperty(xml, prop.key, prop.value, vendor);
          }
        }
        if (this.config.position != null) {
          vendor.setAttribute("position", this.config.position);
        }
        if (this.config.params != null) {
          if (this.config.params.adTag != null) {
            this.createProperty(xml, "DFP_AD_TAG_PARAMS", this.config.params.adTag, vendor);
          }
          if (this.config.params.manual != null) {
            this.createProperty(xml, "DFP_MANUAL_PARAMS", this.config.params.manual, vendor);
          }
        }
        if (this.config.companions != null) {
          companions = [];
          ids = [];
          ref = this.config.companions;
          for (j = 0, len1 = ref.length; j < len1; j++) {
            companion = ref[j];
            companions.push(companion.width + "x" + companion.height);
            ids.push(companion.id);
          }
          this.createProperty(xml, "DFP_SIZE", companions.join(","), vendor);
          this.createProperty(xml, "COMPANION_ID", ids.join(","), vendor);
        }
        if (this.config.disableCompanionAds != null) {
          this.createProperty(xml, "disableCompanionAds", this.config.disableCompanionAds, vendor);
        }
        if (this.config.overlay != null) {
          if (this.config.overlay.enabled === true) {
            overlay = xml.createElement("overlay");
            admedia.appendChild(overlay);
          }
          props = [{
            value: "dfp",
            key: "OVERLAY_AD_PARTNER"
          }, {
            value: this.config.overlay.adTagUrl,
            key: "OVERLAY_AD_BASE_URL"
          }, {
            value: this.config.overlay.delay,
            key: "OVERLAY_AD_DELAY"
          }, {
            value: this.config.overlay.interval,
            key: "OVERLAY_AD_INTERVAL"
          }, {
            value: this.config.overlay.duration,
            key: "OVERLAY_AD_DURATION"
          }, {
            value: this.config.overlay.width + "x" + this.config.overlay.height,
            key: "OVERLAY_AD_SIZE"
          }];
          for (k = 0, len2 = props.length; k < len2; k++) {
            prop = props[k];
            if (prop.value != null) {
              this.createProperty(xml, prop.key, prop.value, overlay);
            }
          }
        }
        return xml;
      }
    }, {
      key: "partner",
      get: function get() {
        return "ima";
      }
    }, {
      key: "flashPlugins",
      get: function get() {
        return [{
          id: "GoogleIMAPlugin",
          src: '#{paths.resources}plugins/GoogleIMAPlugin.swf',
          blocking: false,
          host: "akamai",
          main: "GoogleIMAPlugin",
          type: "application/x-shockwave-flash"
        }, {
          id: "IMAOverlayAdPlugin",
          src: '#{paths.resources}plugins/IMAOverlayAdPlugin.swf',
          blocking: false,
          host: "akamai",
          main: "IMAOverlayAdPlugin",
          type: "application/x-shockwave-flash"
        }, {
          id: "AdOptionsPlugin",
          src: '#{paths.resources}plugins/AdOptionsPlugin.swf',
          blocking: false,
          host: "akamai",
          main: "AdOptionsPlugin",
          type: "application/x-shockwave-flash"
        }];
      }
    }], [{
      key: "NAME",
      get: function get() {
        return "IMAWrapper";
      }
    }]);
    return _IMAWrapper;
  }(akamai.amp.ads.AdWrapper);

  akamai.amp.AMP.registerPlugin("ima", "flash", akamai.amp.Plugin.createPureMVCFlashFactory(_IMAWrapper));
} catch (error) {
  IMAWrapper = {};
}

var IMAOverlayProxy = function (_akamai$amp$DataBound) {
  babelHelpers.inherits(IMAOverlayProxy, _akamai$amp$DataBound);

  /**
   * Used to trigger overlay ads for Google IMA
   *
   * @constructor
   * @private
   */
  function IMAOverlayProxy(config) {
    babelHelpers.classCallCheck(this, IMAOverlayProxy);

    var _this = babelHelpers.possibleConstructorReturn(this, (IMAOverlayProxy.__proto__ || Object.getPrototypeOf(IMAOverlayProxy)).call(this, config));

    _this.configurationName = "imaoverlay";
    _this.durationTimer = null;
    _this.intervalTimer = null;
    _this.delayTimer = null;
    return _this;
  }

  babelHelpers.createClass(IMAOverlayProxy, [{
    key: "stop",


    /** Stops polling and clears the ad */
    value: function stop() {
      this.facade.player.timers.clearTimeout(this.durationTimer);
      this.facade.player.timers.clearTimeout(this.delayTimer);
      this.facade.player.timers.clearTimeout(this.intervalTimer);
    }

    /** Starts polling and load the first ad */

  }, {
    key: "play",
    value: function play() {
      var _this2 = this;

      this.stop();
      //Set up a delay timer
      this.delayTimer = this.facade.player.timers.setTimeout(function () {
        return _this2.requestAd();
      }, this.value.delay * 1000);
    }

    /** Retrieves an ad image from VAST XML */

  }, {
    key: "requestAd",
    value: function requestAd() {
      var adTagUrl;
      // get the VAST XML
      adTagUrl = this.getValue("adTagUrl");
      if (adTagUrl != null) {
        adTagUrl = adTagUrl.replace("[timestamp]", new Date().getTime());
        adTagUrl = adTagUrl.replace("__random-number__", new Date().getTime());
      }
      Utils.request({
        url: adTagUrl,
        withCredentials: true
      }).then(this.vastLoadHandler.bind(this)).catch(this.error.bind(this));
    }
  }, {
    key: "vastLoadHandler",
    value: function vastLoadHandler(xhr) {
      var ad, clickThroughHref, creativeView, error, img, impression, xml;
      xml = xhr.target.responseXML;
      if (xml != null) {
        try {
          // parse the VAST XML
          ad = xml.querySelector("NonLinear");
          if (ad != null) {
            impression = xml.querySelector("Impression") != null ? xml.querySelector("Impression").textContent : "";
            creativeView = xml.querySelector("Tracking[event=creativeView]") != null ? xml.querySelector("Tracking[event=creativeView]").textContent : "";
            clickThroughHref = ad.querySelector("NonLinearClickThrough") != null ? ad.querySelector("NonLinearClickThrough").textContent : "";
            img = {
              src: ad.querySelector("StaticResource").textContent,
              width: ad.getAttribute("width"),
              height: ad.getAttribute("height"),
              tracking: [impression, creativeView],
              href: clickThroughHref
            };
            this.displayAd(img);
          } else {
            this.error("No overlay was returned");
          }
        } catch (error1) {
          error = error1;
          this.error(error);
        }
      }
    }
  }, {
    key: "error",
    value: function error(_error) {
      this.facade.logger.error("[AMP IMA OVERLAY ERROR]", _error);
      this.stop();
    }

    /** Notifies the application that a new overlay is ready to display */

  }, {
    key: "displayAd",
    value: function displayAd(ad) {
      var _this3 = this;

      // Notify the view
      this.sendNotification(IMANotifications.ADD_OVERLAY, ad);
      // set up the duration timer
      this.durationTimer = this.facade.player.timers.setTimeout(function () {
        _this3.sendNotification(IMANotifications.REMOVE_OVERLAY);
        //Set up a interval timer
        return _this3.intervalTimer = _this3.facade.player.timers.setTimeout(function () {
          return _this3.requestAd();
        }, _this3.value.interval * 1000);
      }, this.value.duration * 1000);
    }
  }, {
    key: "defaults",
    get: function get() {
      return {
        adTagUrl: null,
        duration: 15,
        interval: 30,
        delay: 30
      };
    }
  }], [{
    key: "NAME",
    get: function get() {
      return "IMAOveralyProxy";
    }
  }]);
  return IMAOverlayProxy;
}(akamai.amp.DataBoundConfigurationProxy);

var IMAProxy = function (_akamai$amp$ads$AdPro) {
  babelHelpers.inherits(IMAProxy, _akamai$amp$ads$AdPro);

  /**
   * The IMAProxy class.
   *
   * @constructor
   * @private
   * @extends {AdProxy}
   * @param {Object} config
   */
  function IMAProxy(config) {
    babelHelpers.classCallCheck(this, IMAProxy);

    var _this = babelHelpers.possibleConstructorReturn(this, (IMAProxy.__proto__ || Object.getPrototypeOf(IMAProxy)).call(this, config));

    _this.intervals = [];
    _this.partner = "ima";
    _this.key = "ima";
    _this.adDisplayContainer = null;
    _this.adDisplayContainerInitialized = false;
    _this.adsLoader = null;
    _this.adsRenderingSettings = null;
    _this.adsManagerLoaded = false;
    _this.adsManager = null;
    _this.cuepoints = null;
    _this.adLoaded = false;
    _this.playWhenLoaded = false;
    _this.contentHasEnded = false;
    _this.adTagUrl = null;
    _this.viewMode = null;
    _this.playbackCore = null;
    _this.loadedmetadata = _this.onLoadedMetadata.bind(_this);
    _this.adVO = _this.createDefaultAdVO();
    return _this;
  }

  /** @static */


  babelHelpers.createClass(IMAProxy, [{
    key: "setEnabled",


    /** */
    value: function setEnabled(value) {
      var ref;
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "setEnabled", this).call(this, value);
      if (value === false) {
        if ((ref = this.adsManager) != null) {
          if (typeof ref.destroy === "function") {
            ref.destroy();
          }
        }
        if (this.getInProgress()) {
          this.contentPlay();
        }
      }
      return value;
    }

    /** @override */

  }, {
    key: "onLoadedMetadata",
    value: function onLoadedMetadata(event) {
      if (this.canPlay() && this.playWhenLoaded === true) {
        this.startAd();
      }
    }

    /** @override */

  }, {
    key: "initialize",
    value: function initialize() {}

    /** @override */
    //@facade.player.getViewComponent().addEventListener("resize", @resize.bind(@))

  }, {
    key: "ready",
    value: function ready() {
      var isAndroidChrome, mode, ref, userAgentMatch;
      this.viewMode = google.ima.ViewMode.NORMAL;
      window.addEventListener("resize", this.resize.bind(this));
      //TODO: setVpaidAllowed is a depricated function. Remove this once its deemed safe.
      if (this.config.vpaidAllowed != null) {
        google.ima.settings.setVpaidAllowed(this.config.vpaidAllowed);
      }
      if (this.config.vpaidMode != null && (mode = google.ima.ImaSdkSettings.VpaidMode[this.config.vpaidMode.toUpperCase()]) != null) {
        google.ima.settings.setVpaidMode(mode);
      }
      if (this.config.disableFlashAds != null) {
        google.ima.settings.setDisableFlashAds(this.config.disableFlashAds);
      }
      this.adDisplayContainer = this.createPlugin();
      // Create ads loader.
      this.adsLoader = new google.ima.AdsLoader(this.adDisplayContainer);
      this.autoplay = this.getValue("autoPlayAdBreaks");
      if (this.autoplay != null) this.adsLoader.getSettings().setAutoPlayAdBreaks(this.autoplay);

      userAgentMatch = navigator.userAgent.match(/Chrom(e|ium)\/([0-9]+)\./);
      isAndroidChrome = userAgentMatch ? parseInt(userAgentMatch[2], 10) > 52 : false;
      if ((((ref = akamai.amp.Utils.getIOSversion()) != null ? ref[0] : void 0) >= 10 || isAndroidChrome) && this.facade.player.getConfig().playsinline !== false) {
        google.ima.settings.setDisableCustomPlaybackForIOS10Plus(true);
      }
      this.adsRenderingSettings = new google.ima.AdsRenderingSettings();
      //Removing custom playback flag
      //@adsRenderingSettings.restoreCustomPlaybackStateOnAdBreakComplete = true

      // Listen and respond to ads loaded and error events.
      this.adsLoader.addEventListener(google.ima.AdsManagerLoadedEvent.Type.ADS_MANAGER_LOADED, this.onAdsManagerLoaded.bind(this), false);
      this.adsLoader.addEventListener(google.ima.AdErrorEvent.Type.AD_ERROR, this.onAdError.bind(this), false);
    }

    /** @override */

  }, {
    key: "createPlugin",
    value: function createPlugin() {
      return new google.ima.AdDisplayContainer(this.getContainer());
    }

    /** @override */

  }, {
    key: "engage",
    value: function engage() {
      var override = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var ref, ref1;
      if (this.getEnabled() === false) {
        return;
      }
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "engage", this).call(this);
      if (this.adsManagerLoaded === true && this.contentHasEnded === false || this.contentHasEnded === true && ((ref = this.adVO) != null ? ref.type : void 0) === "postroll") {
        if ((ref1 = this.adsManager) != null) {
          if (typeof ref1.destroy === "function") {
            ref1.destroy();
          }
        }
      }
      //@contentEnded()
      this.adsManagerLoaded = false;
      this.contentHasEnded = false;
      this.adsManagerLoaded = false;
      this.playWhenLoaded = false;
    }

    /** */

  }, {
    key: "setVolume",
    value: function setVolume(value) {
      var ref;
      if ((ref = this.adsManager) != null) {
        ref.setVolume(value);
      }
      return value;
    }

    /** */

  }, {
    key: "getVolume",
    value: function getVolume() {
      var ref;
      return (ref = this.adsManager) != null ? ref.getVolume() : void 0;
    }

    /** @override */

  }, {
    key: "requestAd",
    value: function requestAd() {
      var _this2 = this;

      var adsRequest, dimensions, height, ref, ref1, settings, width;
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "requestAd", this).call(this);
      dimensions = this.getDimensions();
      width = dimensions.clientWidth;
      height = dimensions.clientHeight;
      // Request video ads.
      adsRequest = new google.ima.AdsRequest();
      this.adTagUrl = this.getValue("adTagUrl");
      if (babelHelpers.typeof(this.adTagUrl) === "object") {
        this.adTagUrl = this.buildAdTagUrl(this.adTagUrl);
      }
      adsRequest.adTagUrl = this.adTagUrl;
      if (adsRequest.adsResponse == null && adsRequest.adTagUrl == null) {
        this.onAdError("No valid adTagUrl or adsResponse provided.");
        return;
      }
      // Specify the linear and nonlinear slot sizes. This helps the SDK to
      // select the correct creative if multiple are returned.
      adsRequest.linearAdSlotWidth = width;
      adsRequest.linearAdSlotHeight = height;
      adsRequest.nonLinearAdSlotWidth = ((ref = this.value.overlay) != null ? ref.width : void 0) || width;
      adsRequest.nonLinearAdSlotHeight = ((ref1 = this.value.overlay) != null ? ref1.height : void 0) || height;
      settings = this.adsLoader.getSettings();
      // set the PPID if it was supplied in the config
      if (this.config.ppid != null) {
        settings.setPpid(this.getValue("ppid"));
      }

      var params = { adsRequest: adsRequest, adsLoader: this.adsLoader, adsRenderingSettings: this.adsRenderingSettings, adDisplayContainer: this.adDisplayContainer };
      var request = akamai.amp.ads.AdRequest.create(adsRequest, "ima", this.getData(), params);
      Promise.resolve(request).then(function (ad) {
        var adsResponse = _this2.getValue("adsResponse");
        if (adsResponse != null && adsResponse !== "") {
          return akamai.amp.Utils.requestText(adsResponse).then(function (text) {
            ad.request.adsResponse = text;
            return ad;
          });
        } else {
          return ad;
        }
      }).then(this.processAdRequest).then(function (result) {
        return _this2.adsLoader.requestAds(result.request);
      });
    }

    /** @override */

  }, {
    key: "requestOverlay",
    value: function requestOverlay() {
      var adsRequest, overlay;
      overlay = this.value.overlay;
      if (overlay == null) {
        return;
      }
      // Request overlay ads.
      adsRequest = new google.ima.AdsRequest();
      adsRequest.adTagUrl = overlay.adTagUrl;
      adsRequest.nonLinearAdSlotWidth = overlay.width || 300;
      adsRequest.nonLinearAdSlotHeight = overlay.height || 50;
      this.adsLoader.requestAds(adsRequest);
    }

    /** @override */

  }, {
    key: "start",
    value: function start() {
      var load = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var video;
      if (load === true) {
        this.playbackCore = this.facade.player.retrieveProxy(akamai.amp.PlayerProxy.NAME).getActivePlaybackCore();
        video = this.getMediaElement();
        video.once("loadedmetadata", this.loadedmetadata);
        this.playbackCore.setEnabled(false);
        if (this.facade.isFullscreenDevice()) {
          this.playbackCore.load();
        } else {
          video.load();
        }
      } else {
        this.engage();
      }
      if (babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "start", this).call(this) === false) {
        return false;
      }
      this.isLiveMidroll = load === false && this.facade.player.retrieveProxy(MediaProxy.NAME).getTemporalType() === "live";
      // Initialize the container, if requestAds is invoked in a user action.
      // This is only needed on iOS/Android devices.
      if (this.adDisplayContainerInitialized !== true) {
        this.adDisplayContainer.initialize();
        this.adDisplayContainerInitialized = true;
      }
      if (this.canPlay() === true && load === true) {
        this.startAd();
      } else {
        this.playWhenLoaded = true;
        this.requestAd();
      }
    }

    /** */

  }, {
    key: "canPlay",
    value: function canPlay() {
      return this.adsManagerLoaded === true;
    }

    /** */

  }, {
    key: "getType",
    value: function getType(time) {
      return time === 0 ? "preroll" : time === -1 ? "postroll" : "midroll";
    }

    /** */

  }, {
    key: "createAdVO",
    value: function createAdVO(ad) {
      var linear, pos, type;
      linear = ad.isLinear();
      pos = ad.getAdPodInfo().getPodIndex();
      type = !linear ? "overlay" : this.getType(pos);
      return akamai.amp.Ad.create(ad.getAdId(), ad.getAdId(), ad.getDuration(), pos, type, "ima", null, null, this.adTagUrl, ad, ad.getAdPodInfo().getTotalAds(), ad.getDuration() - this.adsManager.getRemainingTime());
    }

    /** */

  }, {
    key: "startAd",
    value: function startAd() {
      var adError;
      this.playWhenLoaded = false;
      try {
        // Initialize the ads manager. Ad rules playlist will start at this time.
        if (this.viewMode == null) {
          this.viewMode = google.ima.ViewMode.NORMAL;
        }
        this.adsManager.init(this.facade.player.getViewComponent().clientWidth, this.facade.player.getViewComponent().clientHeight, this.viewMode);

        // Call start manually to ensure VPAID ads begin playback
        if (this.autoplay !== false) {
          this.adsManager.start();
        }
      } catch (adError) {
        // An error may be thrown if there was a problem with the VAST response.
        this.error(adError);
      }
    }
  }, {
    key: "getViewMode",
    value: function getViewMode() {
      return this.facade.player.displayState == akamai.amp.DisplayState.FULL_SCREEN ? google.ima.ViewMode.FULLSCREEN : google.ima.ViewMode.NORMAL;
    }
  }, {
    key: "resize",
    value: function resize() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.facade.player.displayState;
      var dimensions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.getDimensions();

      var viewMode = this.viewMode;

      if (state === akamai.amp.DisplayState.FULL_SCREEN) {
        viewMode = google.ima.ViewMode.FULLSCREEN;
      } else if (state === akamai.amp.DisplayState.NORMAL) {
        viewMode = google.ima.ViewMode.NORMAL;
      }

      if (viewMode == this.viewMode && this.dimensions != null && this.dimensions.width === dimensions.width && this.dimensions.height === dimensions.height) {
        return;
      }

      this.dimensions = dimensions;
      this.viewMode = viewMode;

      if (this.adsManager == null) return;

      this.adsManager.resize(this.dimensions.width, this.dimensions.height, this.viewMode);
    }

    /** */

  }, {
    key: "onAdBreakReady",
    value: function onAdBreakReady(event) {
      var _this3 = this;

      var start = function start() {
        // Call play to start showing the ad. Single video and overlay ads will
        // start at this time; the call will be ignored for ad rules.
        _this3.adsManager.start();
      };

      if (this.autoplay !== false) {
        start();
      } else {
        var ad = akamai.amp.Ad.create(null, null, 0, 0, this.getType(event.getAdData().adBreakTime), "ima");
        this.processAdBreak(ad).then(function (result) {
          if (result != null) {
            start();
          } else {
            if (ad.type === "postroll") {
              _this3.endBreak();
            }
          }
        });
      }
    }

    /** */

  }, {
    key: "onAdsManagerLoaded",
    value: function onAdsManagerLoaded(adsManagerLoadedEvent) {
      var _this4 = this;

      var adEventHandler, ref;
      // Get the ads manager.
      this.adsRenderingSettings.bitrate = this.getValue("maxBitrate");
      //Auto Aligning the Overlay Ads
      this.adsRenderingSettings.autoAlign = true;
      //Close button for Overlay Ads
      this.adsRenderingSettings.useStyledNonLinearAds = true;

      var settings = this.getValue("adsRenderingSettings");
      if (settings != null) {
        Object.entries(settings).forEach(function (entry) {
          _this4.adsRenderingSettings[entry[0]] = entry[1];
        });
      }

      // Check adsManager isntance to avoid multiple instances.
      if ((ref = this.adsManager) != null) {
        if (typeof ref.destroy === "function") {
          ref.destroy();
        }
      }
      this.adsManager = adsManagerLoadedEvent.getAdsManager(this.facade.player.mediaElement, this.adsRenderingSettings); // should be set to the content video element
      this.sendNotification(akamai.amp.ads.AdNotifications.AD_MANAGER_LOADED, {
        "adManager": this.adsManager,
        "viewMode": this.getViewMode(),
        "adContainer": this.getContainer()
      });
      this.adsManagerLoaded = true;
      this.cuePoints = this.adsManager.getCuePoints();
      this.setCues(this.cuePoints);
      if (this.cuePoints.indexOf(-1) !== -1) {
        this.sendNotification(akamai.amp.Notifications.HAS_POST_CONTENT, true);
      }
      adEventHandler = this.onAdEvent.bind(this);
      // Add listeners to the required events.
      this.adsManager.addEventListener(google.ima.AdErrorEvent.Type.AD_ERROR, this.onAdError.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.CONTENT_PAUSE_REQUESTED, this.contentPause.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.CONTENT_RESUME_REQUESTED, this.contentPlay.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.ALL_ADS_COMPLETED, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.AD_BREAK_READY, this.onAdBreakReady.bind(this));

      // Listen to any additional events, if necessary.
      this.adsManager.addEventListener(google.ima.AdEvent.Type.LOADED, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.STARTED, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.RESUMED, this.onAdResumed.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.PAUSED, this.onAdPaused.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.COMPLETE, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.CLICK, this.onAdClick.bind(this));
      this.adsManager.addEventListener(google.ima.AdEvent.Type.IMPRESSION, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.FIRST_QUARTILE, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.MIDPOINT, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.THIRD_QUARTILE, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.SKIPPED, adEventHandler);
      this.adsManager.addEventListener(google.ima.AdEvent.Type.LOG, adEventHandler);
      this.sendNotification(akamai.amp.ads.AdNotifications.REQUEST_COMPLETE, {
        pods: this.cuePoints
      });
      this.sendNotification(akamai.amp.ads.AdNotifications.RESPONSE, {
        pods: this.cuePoints,
        response: adsManagerLoadedEvent,
        adsManager: this.adsManager
      });
      if (this.canPlay() && this.playWhenLoaded === true) {
        this.startAd();
      }
    }

    /** */

  }, {
    key: "onAdClick",
    value: function onAdClick(adEvent) {
      if ((adEvent != null ? adEvent.getAd().isLinear() : void 0) === false) {
        this.facade.player.sendNotification(akamai.amp.Notifications.PAUSE);
        return;
      }
      if (!this.getPaused()) {
        this.pause();
      }
      this.sendNotification(akamai.amp.ads.AdNotifications.AD_CLICKED, this.adVO);
    }

    /** */

  }, {
    key: "onAdPaused",
    value: function onAdPaused(adEvent) {
      this.setPaused(true);
      this.facade.player.sendNotification(akamai.amp.Notifications.CHANGE_PLAY_STATE, akamai.amp.PlayState.PAUSED);
      this.facade.player.sendNotification(akamai.amp.Notifications.CHANGE_ACTIVE_STATE, akamai.amp.ActiveState.ACTIVE);
      this.sendNotification(akamai.amp.ads.AdNotifications.AD_PAUSED, this.adVO);
    }

    /** */

  }, {
    key: "onAdResumed",
    value: function onAdResumed(adEvent) {
      this.setPaused(false);
      this.facade.player.sendNotification(akamai.amp.Notifications.CHANGE_PLAY_STATE, akamai.amp.PlayState.PLAYING);
    }

    /** */

  }, {
    key: "onAdEvent",
    value: function onAdEvent(adEvent) {
      var ad, companion, companions, config, error, i, len, ref, ref1;
      // Retrieve the ad from the event. Some events (e.g. ALL_ADS_COMPLETED)
      // don't have ad object associated.
      ad = adEvent.getAd();
      if (this.adVO != null) {
        if (ad != null) {
          ad.wrapperAdIds = typeof ad.getWrapperAdIds === "function" ? ad.getWrapperAdIds() : void 0;
          ad.wrapperAdSystems = typeof ad.getWrapperAdSystems === "function" ? ad.getWrapperAdSystems() : void 0;
        }
        this.adVO.metadata = ad;
      }
      switch (adEvent.type) {
        case google.ima.AdEvent.Type.IMPRESSION:
          this.adVO = this.createAdVO(ad);
          this.sendNotification(akamai.amp.ads.AdNotifications.IMPRESSION, this.adVO);
          break;
        case google.ima.AdEvent.Type.LOADED:
          // This is the first event sent for an ad - it is possible to
          // determine whether the ad is a video ad or an overlay.
          if (ad.isLinear()) {
            this.facade.player.sendNotification(akamai.amp.Notifications.REMOVE_APPLICATION_STATE, "ad-overlaymode");
            this.adVO = this.createAdVO(ad);
            if (!this.getInProgress() && this.adVO.type === "midroll" || this.adVO.type === "postroll") {
              this.startBreak();
              this.engageAds();
            }
            this.resize();
            this.sendNotification(akamai.amp.ads.AdNotifications.AD_LOADED, this.adVO);
            this.sendNotification(akamai.amp.ads.AdNotifications.AD_DURATION_CHANGE, this.adVO);
            //Register (engage) events when switching back to ad playback
            this.setVolume(this.facade.player.retrieveProxy(akamai.amp.ApplicationStateProxy.NAME).getVolume());
          } else {
            // Skip to Content Play if its Overlay ads
            this.facade.player.sendNotification(akamai.amp.Notifications.ADD_APPLICATION_STATE, "ad-overlaymode");
            this.contentPlay();
          }
          break;
        case google.ima.AdEvent.Type.STARTED:
          // This event indicates the ad has started - the video player
          // can adjust the UI, for example display a pause buIton and
          // remaining time.
          if (ad.isLinear()) {
            this.adVO.position = ad.getAdPodInfo().getAdPosition();
            this.sendNotification(akamai.amp.ads.AdNotifications.AD_STARTED, this.adVO);
            // For a linear ad, a timer can be started to poll for
            // the remaining time.
            this.intervals.push(this.facade.player.timers.setInterval(this.onAdTimeUpdate.bind(this), 67));
            this.facade.player.sendNotification(akamai.amp.Notifications.CHANGE_PLAY_STATE, akamai.amp.PlayState.PLAYING);
            this.sendNotification(akamai.amp.ads.AdNotifications.AD_PLAY, this.adVO);
          }
          try {
            companions = [];
            config = (typeof this.getConfigurationData === "function" ? (ref = this.getConfigurationData()) != null ? ref.companions : void 0 : void 0) || [];
            for (i = 0, len = config.length; i < len; i++) {
              companion = config[i];
              companions = companions.concat(ad.getCompanionAds(companion.width, companion.height));
            }
            if ((companions != null ? companions.length : void 0) > 0) {
              this.setCompanions(companions);
            }
          } catch (error1) {
            error = error1;
            this.facade.logger.error("[AMP IMA ERROR]", "Could not retrieve companion ads:", error);
          }
          break;
        case google.ima.AdEvent.Type.COMPLETE:
          // This event indicates the ad has finished - the video player
          // can perform appropriate UI actions, such as removing the timer for
          // remaining time detection.
          if (ad.isLinear()) {
            this.sendNotification(akamai.amp.ads.AdNotifications.AD_ENDED, this.adVO);
          }
          break;
        case google.ima.AdEvent.Type.FIRST_QUARTILE:
          this.sendNotification(akamai.amp.ads.AdNotifications.FIRST_QUARTILE, this.adVO);
          break;
        case google.ima.AdEvent.Type.MIDPOINT:
          this.sendNotification(akamai.amp.ads.AdNotifications.MIDPOINT, this.adVO);
          break;
        case google.ima.AdEvent.Type.THIRD_QUARTILE:
          this.sendNotification(akamai.amp.ads.AdNotifications.THIRD_QUARTILE, this.adVO);
          break;
        case google.ima.AdEvent.Type.LOG:
          if (this.facade.player.retrieveProxy(akamai.amp.ApplicationStateProxy.NAME).getEnded() === true && ((ref1 = adEvent.getAdData()) != null ? ref1.adError : void 0) != null) {
            this.forceBreakEnd = true;
          }
          if (this.getValue("logEventsEnabled") === true) {
            this.sendNotification(akamai.amp.ads.AdNotifications.LOG, this.adVO);
          }
          break;
        case google.ima.AdEvent.Type.SKIPPED:
          this.sendNotification(akamai.amp.ads.AdNotifications.SKIPPED, this.adVO);
          break;
        case google.ima.AdEvent.Type.ALL_ADS_COMPLETED:
          // This event indicates the ad has finished - the video player
          // can perform appropriate UI actions, such as removing the timer for
          // remaining time detection.
          if (this.getInProgress() === true || this.forceBreakEnd === true) {
            this.forceBreakEnd = false;
            this.endBreak();
          }
      }
    }

    /** */

  }, {
    key: "getDimensions",
    value: function getDimensions() {
      var container;
      container = this.getContainer();
      return {
        width: container.clientWidth,
        height: container.clientHeight
      };
    }

    /** */

  }, {
    key: "onAdTimeUpdate",
    value: function onAdTimeUpdate(adEvent) {
      var remaining, time;
      this.resize();
      remaining = akamai.amp.Utils.clamp(this.adsManager.getRemainingTime(), 0, this.adVO.duration);
      time = Math.max(this.adVO.duration - remaining, 0);
      this.adVO.time = time;
      this.sendNotification(akamai.amp.ads.AdNotifications.AD_TIME_UPDATE, time);
      this.sendNotification(akamai.amp.ads.AdNotifications.AD_TIME_REMAINING, remaining);
    }

    /** */

  }, {
    key: "onAdError",
    value: function onAdError(adErrorEvent) {
      var error;
      // Handle the error logging.
      //@adManager.destroy()
      error = (adErrorEvent != null ? typeof adErrorEvent.getError === "function" ? adErrorEvent.getError() : void 0 : void 0) || adErrorEvent;
      // if /AdError 1205/.test(error.getInnerError()?.message)
      //   return
      this.error(error);
      this.contentPlay();
    }

    /** */

  }, {
    key: "play",
    value: function play() {
      var error, ref;
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "play", this).call(this);
      try {
        if ((ref = this.adsManager) != null) {
          ref.resume();
        }
        // TODO: Remove this (fix one single Notifications which should fired for akamai.amp.ads.AdNotifications.AD_PLAY)
        // HACK: Comscore to detect Ads Resume notifications
        this.sendNotification(akamai.amp.ads.AdNotifications.AD_RESUME);
      } catch (error1) {
        error = error1;
        this.facade.logger.error("[AMP IMA ERROR]", "resume", error);
      }
    }

    /** */

  }, {
    key: "pause",
    value: function pause() {
      var error;
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "pause", this).call(this);
      if (this.adsManager != null) {
        try {
          this.adsManager.pause();
        } catch (error1) {
          error = error1;
          this.facade.logger.error("[AMP IMA ERROR]", "pause", error);
        }
      } else {
        this.playWhenLoaded = false;
      }
    }

    /** */

  }, {
    key: "clearIntervals",
    value: function clearIntervals() {
      var i, interval, len, ref;
      ref = this.intervals;
      for (i = 0, len = ref.length; i < len; i++) {
        interval = ref[i];
        this.facade.player.timers.clearInterval(interval);
      }
      this.intervals = [];
    }

    /** */

  }, {
    key: "breakEnd",
    value: function breakEnd() {
      var overlayProxy;
      this.clearIntervals();
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "breakEnd", this).call(this);
      overlayProxy = this.facade.retrieveProxy(IMAOverlayProxy.NAME);
      if (overlayProxy != null) {
        overlayProxy.play();
      }
    }

    /** */

  }, {
    key: "setCompanions",
    value: function setCompanions(value) {
      var companion, companions, i, len, ref;
      //TODO: transform the IMA array to our companion interface
      companions = [];
      for (i = 0, len = value.length; i < len; i++) {
        companion = value[i];
        companions.push({
          data: companion.getContent(),
          type: (ref = companion.getContentType()) != null ? ref.toLowerCase() : void 0,
          width: companion.getWidth(),
          height: companion.getHeight(),
          metadata: companion
        });
      }
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "setCompanions", this).call(this, companions);
      return value;
    }

    /** */

  }, {
    key: "contentPause",
    value: function contentPause() {
      var _this5 = this;

      var events;
      events = ["pause", "waiting", "playing", "ended", "durationchange", "error"];
      if (this.facade.player.retrieveProxy(akamai.amp.ApplicationStateProxy.NAME).getSeeking() === false) {
        events.push("seeked");
      } else {
        this.getMediaElement().once("seeked", function () {
          _this5.sendNotification(akamai.amp.Notifications.DISABLE_VIDEO_EVENTS, ["seeked"]);
        });
      }
      this.sendNotification(akamai.amp.Notifications.DISABLE_VIDEO_EVENTS, events);
      if (this.isLiveMidroll === true) {
        this.getMediaElement().volume = 0;
        return;
      }
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "contentPause", this).call(this);
    }

    /** */

  }, {
    key: "contentPlay",
    value: function contentPlay() {
      var ref, ref1;
      if (this.getInProgress() === true) {
        this.endBreak();
      }
      this.sendNotification(akamai.amp.Notifications.ENABLE_VIDEO_EVENTS, ["pause", "seeked", "waiting", "playing", "ended", "durationchange", "error"]);
      if (((ref = this.adVO) != null ? ref.type : void 0) === "postroll") {
        return;
      }
      if (this.isLiveMidroll === true) {
        this.getMediaElement().volume = this.facade.player.retrieveProxy(akamai.amp.ApplicationStateProxy.NAME).getVolume();
        if (akamai.amp.Utils.getDevice() === "ipad") {
          this.getMediaElement().load();
        } else {
          return;
        }
      }
      babelHelpers.get(IMAProxy.prototype.__proto__ || Object.getPrototypeOf(IMAProxy.prototype), "contentPlay", this).call(this);
      // HACK: Post midroll video starts from the begining (html-319, html-305)
      if (((ref1 = this.adVO) != null ? ref1.type : void 0) === "midroll" && akamai.amp.Utils.getDevice() === "desktop") {
        this.facade.player.setCurrentTime(Math.floor(this.facade.player.getCurrentTime()));
      }
    }

    /** */

  }, {
    key: "contentEnded",
    value: function contentEnded() {
      var error, ref;
      this.contentHasEnded = true;
      try {
        //@adsManager?.destroy?()
        if ((ref = this.adsLoader) != null) {
          if (typeof ref.contentComplete === "function") {
            ref.contentComplete();
          }
        }
      } catch (error1) {
        error = error1;
        this.facade.logger.error("[AMP IMA ERROR]", "contentComplete", error);
      }
    }

    /** */

  }, {
    key: "terminateAd",
    value: function terminateAd() {
      var error, ref;
      try {
        if ((ref = this.adsManager) != null) {
          ref.stop();
        }
      } catch (error1) {
        error = error1;
        this.facade.logger.error("[AMP IMA ERROR]", "terminateAd", error);
      }
      if (this.adVO.type === "postrol") {
        this.sendNotification(akamai.amp.Notifications.HAS_POST_CONTENT, false);
      }
      this.endBreak();
      this.contentPlay();
    }

    /** */

  }, {
    key: "terminateAllAds",
    value: function terminateAllAds() {
      var error, ref;
      try {
        if ((ref = this.adsManager) != null) {
          ref.destroy();
        }
      } catch (error1) {
        error = error1;
        this.facade.logger.error("[AMP IMA ERROR]", "terminateAllAds", error);
      }
      this.sendNotification(akamai.amp.Notifications.HAS_POST_CONTENT, false);
      this.endBreak();
      this.contentPlay();
    }

    /** */

  }, {
    key: "destroy",
    value: function destroy() {
      var ref;
      this.clearIntervals();
      if ((ref = this.adsManager) != null) {
        if (typeof ref.destroy === "function") {
          ref.destroy();
        }
      }
    }

    /** */

  }, {
    key: "buildAdTagUrl",
    value: function buildAdTagUrl(adTagObj) {
      var adTagUrl;
      adTagUrl = adTagObj.base || "//pubads.g.doubleclick.net/gampad/ads";
      adTagUrl += "?" + this.encodeAdTagParams(adTagObj.params);
      return adTagUrl;
    }

    /** */

  }, {
    key: "encodeAdTagParams",
    value: function encodeAdTagParams(params) {
      var adTagParams, key, value;
      adTagParams = [];
      for (key in params) {
        value = params[key];
        if ((typeof value === "undefined" ? "undefined" : babelHelpers.typeof(value)) === "object") {
          value = encodeURIComponent(this.encodeAdTagParams(value));
        }
        adTagParams.push(key + "=" + value);
      }
      return adTagParams.join("&");
    }
  }, {
    key: "defaults",
    get: function get() {
      return {
        adTagUrl: null,
        overlay: null,
        width: null,
        height: null,
        maxBitrate: -1,
        ppid: null,
        autoPlayAdBreaks: null,
        companions: null,
        logEventsEnabled: false,
        adsRenderingSettings: null
      };
    }
  }], [{
    key: "NAME",
    get: function get() {
      return akamai.amp.ads.AdProxy.NAME;
    }
  }]);
  return IMAProxy;
}(akamai.amp.ads.AdProxy);

var IMAFullscreenProxy = function (_IMAProxy) {
  babelHelpers.inherits(IMAFullscreenProxy, _IMAProxy);

  /**
   * The IMAFullscreenProxy class.
   *
   * @constructor
   * @private
   * @extends {IMAProxy}
   * @param   {Object}    config  The configuration object.
   */
  function IMAFullscreenProxy(config) {
    babelHelpers.classCallCheck(this, IMAFullscreenProxy);
    return babelHelpers.possibleConstructorReturn(this, (IMAFullscreenProxy.__proto__ || Object.getPrototypeOf(IMAFullscreenProxy)).call(this, config));
  }

  babelHelpers.createClass(IMAFullscreenProxy, [{
    key: "createPlugin",


    /** */
    value: function createPlugin() {
      var container, ref, ref1;
      container = this.getContainer();
      if (akamai.amp.Utils.isIPhone() && ((ref = akamai.amp.Utils.getIOSversion()) != null ? ref[0] : void 0) < 10) {
        return new google.ima.AdDisplayContainer(container, this.facade.player.getMediaElement(), container);
      }
      if (((ref1 = akamai.amp.Utils.getIOSversion()) != null ? ref1[0] : void 0) >= 10) {
        this.facade.player.getMediaElement().playsInline = this.facade.player.getConfig().playsinline != null ? this.facade.player.getConfig().playsinline : true;
      }
      return new google.ima.AdDisplayContainer(container, this.facade.player.getMediaElement());
    }

    /** @override */

  }, {
    key: "engage",
    value: function engage(media) {
      babelHelpers.get(IMAFullscreenProxy.prototype.__proto__ || Object.getPrototypeOf(IMAFullscreenProxy.prototype), "engage", this).call(this, media);
      this.sendNotification(akamai.amp.Notifications.DISABLE_VIDEO_EVENTS, ["paused", "ended", "durationchange", "error"]);
    }

    /** @override */

  }, {
    key: "reset",
    value: function reset(media) {
      babelHelpers.get(IMAFullscreenProxy.prototype.__proto__ || Object.getPrototypeOf(IMAFullscreenProxy.prototype), "reset", this).call(this, media);
      this.sendNotification(akamai.amp.Notifications.ENABLE_VIDEO_EVENTS, ["paused", "ended", "durationchange", "error"]);
    }

    /** @override */

  }, {
    key: "breakStart",
    value: function breakStart() {
      this.playbackCore = this.facade.player.retrieveProxy(akamai.amp.PlayerProxy.NAME).getActivePlaybackCore();
      this.playbackCore.setEnabled(false);
      this.setInProgress(true);
    }

    /** @override */

  }, {
    key: "breakEnd",
    value: function breakEnd() {
      babelHelpers.get(IMAFullscreenProxy.prototype.__proto__ || Object.getPrototypeOf(IMAFullscreenProxy.prototype), "breakEnd", this).call(this);
      this.playbackCore.setEnabled(true);
    }
  }], [{
    key: "NAME",
    get: function get() {
      return IMAProxy.NAME;
    }
  }]);
  return IMAFullscreenProxy;
}(IMAProxy);

var IMAAddOverlayCommand = function (_puremvc$SimpleComman) {
  babelHelpers.inherits(IMAAddOverlayCommand, _puremvc$SimpleComman);

  /**
   * The IMAAddOverlayCommand class.
   *
   * @constructor
   * @private
   * @extends {puremvc.SimpleCommand}
   */
  function IMAAddOverlayCommand() {
    babelHelpers.classCallCheck(this, IMAAddOverlayCommand);
    return babelHelpers.possibleConstructorReturn(this, (IMAAddOverlayCommand.__proto__ || Object.getPrototypeOf(IMAAddOverlayCommand)).call(this));
  }

  /**
   * Executes the command.
   *
   * @param {puremvc.Notification} notification
   *    The notification.
   *
   * @override
   */


  babelHelpers.createClass(IMAAddOverlayCommand, [{
    key: "execute",
    value: function execute(notification) {
      this.facade.sendNotification(akamai.amp.Notifications.ADD_APPLICATION_STATE, "ad-overlay-mode");
    }
  }]);
  return IMAAddOverlayCommand;
}(puremvc.SimpleCommand);

var IMARemoveOverlayCommand = function (_puremvc$SimpleComman) {
  babelHelpers.inherits(IMARemoveOverlayCommand, _puremvc$SimpleComman);

  /**
   * The IMARemoveOverlayCommand class.
   *
   * @constructor
   * @private
   * @extends {puremvc.SimpleCommand}
   */
  function IMARemoveOverlayCommand() {
    babelHelpers.classCallCheck(this, IMARemoveOverlayCommand);
    return babelHelpers.possibleConstructorReturn(this, (IMARemoveOverlayCommand.__proto__ || Object.getPrototypeOf(IMARemoveOverlayCommand)).call(this));
  }

  /**
   * Executes the command.
   *
   * @param {puremvc.Notification} notification
   *    The notification.
   *
   * @override
   */


  babelHelpers.createClass(IMARemoveOverlayCommand, [{
    key: "execute",
    value: function execute(notification) {
      var proxy = this.facade.retrieveProxy(IMAOverlayProxy.NAME);
      proxy.stop();
      this.facade.player.sendNotification(akamai.amp.Notifications.REMOVE_APPLICATION_STATE, "ad-overlay-mode");
    }
  }]);
  return IMARemoveOverlayCommand;
}(puremvc.SimpleCommand);

var IMAOverlayMediator = function (_akamai$amp$OverlayMe) {
  babelHelpers.inherits(IMAOverlayMediator, _akamai$amp$OverlayMe);

  /**
   * The IMAOverlayMediator class.
   *
   * @constructor
   * @private
   * @extends {OverlayMediator}
   * @param {Object} viewComponent
   */
  function IMAOverlayMediator() {
    babelHelpers.classCallCheck(this, IMAOverlayMediator);

    var _this = babelHelpers.possibleConstructorReturn(this, (IMAOverlayMediator.__proto__ || Object.getPrototypeOf(IMAOverlayMediator)).call(this));

    _this.componentName = "ad-overlay";
    _this.anchor = null;
    _this.image = null;
    _this.tracker = null;
    _this.tracker2 = null;
    _this.closeButton = null;
    _this.closeText = null;
    return _this;
  }

  /**
   * @override
   */


  babelHelpers.createClass(IMAOverlayMediator, [{
    key: "onRegister",
    value: function onRegister() {
      var _this2 = this;

      babelHelpers.get(IMAOverlayMediator.prototype.__proto__ || Object.getPrototypeOf(IMAOverlayMediator.prototype), "onRegister", this).call(this);
      this.anchor = this.create("ad-overlay-anchor");
      this.anchor.target = "_blank";
      this.image = this.create("ad-overlay-img", this.anchor, "img");
      this.tracker = this.create();
      this.tracker.width = 0;
      this.tracker.height = 0;
      this.tracker2 = this.create(null, this, "img");
      this.tracker2.width = 0;
      this.tracker2.height = 0;
      this.closeButton = this.create("ad-close-button", this.anchor);
      this.closeButton.onclick = function (event) {
        event.stopImmediatePropagation();
        _this2.sendNotification(IMANotifications.REMOVE_OVERLAY);
        return false;
      };
      this.closeText = this.createText("ad-close-text", "x", this.closeButton);
    }

    /**
     * @override
     */

  }, {
    key: "listNotificationInterests",
    value: function listNotificationInterests() {
      return [IMANotifications.ADD_OVERLAY, IMANotifications.REMOVE_OVERLAY];
    }

    /**
     * @override
     */

  }, {
    key: "handleNotification",
    value: function handleNotification(notification) {
      var ad;
      switch (notification.getName()) {
        case IMANotifications.ADD_OVERLAY:
          ad = notification.getBody();
          this.image.src = ad.src;
          this.anchor.href = ad.href;
          this.tracker.src = ad.tracking[0];
          this.tracker2.src = ad.tracking[1];
      }
    }
  }]);
  return IMAOverlayMediator;
}(akamai.amp.OverlayMediator);

var IMAReadyCommand = function (_puremvc$SimpleComman) {
  babelHelpers.inherits(IMAReadyCommand, _puremvc$SimpleComman);

  /**
   * The IMAReadyCommand class.
   *
   * @constructor
   * @private
   * @extends {puremvc.SimpleCommand}
   */
  function IMAReadyCommand() {
    babelHelpers.classCallCheck(this, IMAReadyCommand);
    return babelHelpers.possibleConstructorReturn(this, (IMAReadyCommand.__proto__ || Object.getPrototypeOf(IMAReadyCommand)).call(this));
  }

  /**
   * Executes the command.
   *
   * @param {puremvc.Notification} notification
   *    The notification.
   *
   * @override
   */


  babelHelpers.createClass(IMAReadyCommand, [{
    key: "execute",
    value: function execute(notification) {
      var _this2 = this;

      // this timeout is needed to allow other plugins to provide an ad container during the ready event
      this.facade.player.timers.setTimeout(function () {
        return _this2.facade.retrieveProxy(IMAProxy.NAME).ready();
      }, 10);
    }
  }]);
  return IMAReadyCommand;
}(puremvc.SimpleCommand);

var IMAActiveStateChangeCommand = function (_puremvc$SimpleComman) {
  babelHelpers.inherits(IMAActiveStateChangeCommand, _puremvc$SimpleComman);

  /**
   * The IMAActiveStateChangeCommand class.
   *
   * @constructor
   * @private
   * @extends {puremvc.SimpleCommand}
   */
  function IMAActiveStateChangeCommand() {
    babelHelpers.classCallCheck(this, IMAActiveStateChangeCommand);
    return babelHelpers.possibleConstructorReturn(this, (IMAActiveStateChangeCommand.__proto__ || Object.getPrototypeOf(IMAActiveStateChangeCommand)).call(this));
  }

  /**
   * Executes the command.
   *
   * @param {puremvc.Notification} notification
   *    The notification.
   *
   * @override
   */


  babelHelpers.createClass(IMAActiveStateChangeCommand, [{
    key: "execute",
    value: function execute(notification) {
      this.facade.retrieveProxy(IMAProxy.NAME).resize(notification.getBody());
    }
  }]);
  return IMAActiveStateChangeCommand;
}(puremvc.SimpleCommand);

var IMAPlugin = function (_akamai$amp$ads$AdPlu) {
  babelHelpers.inherits(IMAPlugin, _akamai$amp$ads$AdPlu);

  /**
   * The IMAPlugin class.
   *
   * @param {Module}  app     The parent module of this plugin.
   * @constructor
   * @private
   * @extends {AdPlugin}
   */
  function IMAPlugin() {
    babelHelpers.classCallCheck(this, IMAPlugin);
    return babelHelpers.possibleConstructorReturn(this, (IMAPlugin.__proto__ || Object.getPrototypeOf(IMAPlugin)).call(this));
  }

  babelHelpers.createClass(IMAPlugin, [{
    key: "createFullscreenProxy",
    value: function createFullscreenProxy() {
      return new IMAFullscreenProxy(this.config);
    }
  }, {
    key: "createProxy",
    value: function createProxy() {
      return new IMAProxy(this.config);
    }
  }, {
    key: "isFullscreenDevice",
    value: function isFullscreenDevice() {
      var ua = navigator.userAgent;
      return this.config.fullscreen === true || akamai.amp.Utils.isFullscreenDevice() || /Android 4\.[0-1]/.test(ua) || /CrKey/.test(ua);
    }

    /** @override */

  }, {
    key: "createModel",
    value: function createModel() {
      babelHelpers.get(IMAPlugin.prototype.__proto__ || Object.getPrototypeOf(IMAPlugin.prototype), "createModel", this).call(this);
      if (this.config.overlay != null) {
        this.registerProxy(new IMAOverlayProxy(this.config.overlay));
      }
    }

    /** @override */

  }, {
    key: "createController",
    value: function createController() {
      babelHelpers.get(IMAPlugin.prototype.__proto__ || Object.getPrototypeOf(IMAPlugin.prototype), "createController", this).call(this);
      if (this.config.overlay != null) {
        this.registerCommand(IMANotifications.ADD_OVERLAY, IMAAddOverlayCommand);
        this.registerCommand(IMANotifications.REMOVE_OVERLAY, IMARemoveOverlayCommand);
      }
      this.registerCommand(akamai.amp.Notifications.READY, IMAReadyCommand);
      this.registerCommand(akamai.amp.Notifications.CHANGE_ACTIVE_STATE, IMAActiveStateChangeCommand);
    }

    /** @override */

  }, {
    key: "createView",
    value: function createView() {
      babelHelpers.get(IMAPlugin.prototype.__proto__ || Object.getPrototypeOf(IMAPlugin.prototype), "createView", this).call(this);
      if (this.config.overlay != null) {
        this.registerMediator(new IMAOverlayMediator());
      }
    }
  }, {
    key: "moduleName",
    get: function get() {
      return "ima";
    }
  }]);
  return IMAPlugin;
}(akamai.amp.ads.AdPlugin);

akamai.amp.AMP.registerPlugin("ima", "html", akamai.amp.Plugin.createPureMVCFactory(IMAPlugin));

exports.IMA = IMAPlugin;

}((this.akamai.amp.ima = this.akamai.amp.ima || {})));
//# sourceMappingURL=Ima.js.map
